--- old/usr/src/lib/libproc/common/Pgcore.c	Mon Oct 15 13:25:15 2018
+++ new/usr/src/lib/libproc/common/Pgcore.c	Mon Oct 15 13:25:15 2018
@@ -25,7 +25,7 @@
  */
 /*
  * Copyright 2012 DEY Storage Systems, Inc.  All rights reserved.
- * Copyright 2015 Joyent, Inc.
+ * Copyright 2018 Joyent, Inc.
  * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 
@@ -509,6 +509,7 @@
 {
 	pgcore_t *pgc = data;
 	struct ps_prochandle *P = pgc->P;
+	prlwpname_t name = { 0, "" };
 	psinfo_t ps;
 
 	/*
@@ -577,6 +578,14 @@
 #endif	/* __sparcv9 */
 #endif	/* sparc */
 
+	if (Plwp_getname(P, lsp->pr_lwpid, name.pr_lwpname,
+	    sizeof (name.pr_lwpname)) == 0) {
+		name.pr_lwpid = lsp->pr_lwpid;
+		if (write_note(pgc->pgc_fd, NT_LWPNAME, &name,
+		    sizeof (name), pgc->pgc_doff) != 0)
+			return (1);
+	}
+
 	if (!(lsp->pr_flags & PR_AGENT))
 		return (0);
 
